#!/usr/bin/perl
####################################################################
#                                                                  #
#  DISCLAIMER:                                                     #
#  In no event will T. O' Donnell be liable to the user of this    # 
#  script or any third party for any damages, including any lost   #
#  profits, lost savings or other incidental, consequential or     #
#  special damages arising out of the operation of or inability to # 
#  operate this script, even if the user has been advised of the   # 
#  possibility of such damages.                                    #
####################################################################
##############################################################################
# COPYRIGHT NOTICE                                                          
# TigerTom's Horatio Script. Version: 1.2, April 2002.                    
#                                                                             
# Copyright 2001-2002 T. O' Donnell.  All Rights Reserved.                        
# http://www.tigertom.com/contact.htm                                        
#                                                                           
# This Perl script may be used and modified by any purchaser so              
# long as this copyright notice and the comments below remain intact.                                                     
#                                                                            
# It may only be used on domains directly owned by the purchaser.                     
#                                                                            
# By using this code you agree to indemnify T. O' Donnell Inc. and T. O'    
# Donnell from any liability that might arise from its use.                                                                
#                                                                           
# Selling the code for this program without prior written consent is         
# expressly forbidden.                                                      
# You must get permission from T. O' Donnell before redistributing this      
# software over the Internet or via any other medium.                                                             
# You may not redistribute an altered version of this program in any form,    
# via any medium.                                                             
#                                                                            
# In all cases copyright and header must remain intact.                     
#                                                                                                
# This Copyright is in full effect in any country that has International    
# Trade Agreements with the United Kingdom Of Great Britain.                
#                                                                            
##############################################################################

# Horatio Enter Script - a password-sharing and hacker filtration script, 
# by T. O' Donnell.  
# Copyright T. O' Donnell, 2001.

use CGI::Carp qw(fatalsToBrowser);

require "/user/yourserver/absolute/path_to/cgi-bin/horatio/tigertom_lib.cgi";
require "/user/yourserver/absolute/path_to/cgi-bin/horatio/horatio_setup.cgi";
require "/user/yourserver/absolute/path_to/cgi-bin/horatio/horatio_lib.cgi";

################### Subroutines #####################

# Check for valid referer
&check_referer;

# read in the data
&parse_data; 

# Check required fields
&required_check;

if ($FORM{'member_name'}) {

# Get the date for the bouncer sub-routines:
&get_date;

# Find member name:
&find_member_name;

# Eject bad user (multiple logins):
&eject_bad_user;

# Record user:
&save_id;

  } # End if

# Redirect them
# # &call_mama;

&redirect_user3;

exit;

########### Sub routines ################



# Check required fields are filled in:
sub required_check {

foreach $field(@required) {
        if (!$FORM{$field}) {

print "Content-type: text/html\n\n";
print "<center><h3><FONT COLOR=\"\#FF0000\">Error - Missing Form Information!</FONT></h3><br></center>\n";
print "It seems that you've forgotten to fill out the ";
print "<b><FONT COLOR=\"#FF0000\">$field</FONT></b> "; 
print "field in the form.\n";
print "Please use your browser's back button and correct this.\n";
print "Thank You.</P>\n";
exit;
      } # End if
    } # End foreach
  
 } # End sub check required



sub find_member_name {

# Open users file and compare to current user:

open (MEMBERS, "<$reg_users_pass_dir/$group_file") || die "Error - cannot open $reg_users_pass_dir/$group_file: $!";
        if($lockit){flock(MEMBERS,2);}
        @pals = <MEMBERS>;
        if($lockit){flock(MEMBERS,8);}
        close (MEMBERS);
foreach $line(@pals) {
           if ($line =~ /$FORM{'member_name'}/ ) {
                $found = 1;                        
          } # End if
        } # End foreach

unless ($found) {
print "Content-type: text/html\n\n";
print "<h3>Error!</h3> <B>User not found.</B><BR><BR>Press the BACK button on your browser,\n";
print " and try again. <BR><BR>Note: User name is <I>case-sensitive.</I><BR>\n";
exit;
   } # End unless

 }  # End subroutine.






