#!/usr/bin/perl
####################################################################
#                                                                  #
#  DISCLAIMER:                                                     #
#  In no event will T. O' Donnell be liable to the user of this    # 
#  script or any third party for any damages, including any lost   #
#  profits, lost savings or other incidental, consequential or     #
#  special damages arising out of the operation of or inability to # 
#  operate this script, even if the user has been advised of the   # 
#  possibility of such damages.                                    #
####################################################################
##############################################################################
# COPYRIGHT NOTICE                                                          
# TigerTom's Horatio Script. Version: 1.2, April 2002.                    
#                                                                             
# Copyright 2001-2002 T. O' Donnell.  All Rights Reserved.                        
# http://www.tigertom.com/contact.htm                                        
#                                                                           
# This Perl script may be used and modified by any purchaser so              
# long as this copyright notice and the comments below remain intact.                                                     
#                                                                            
# It may only be used on domains directly owned by the purchaser.                     
#                                                                            
# By using this code you agree to indemnify T. O' Donnell Inc. and T. O'    
# Donnell from any liability that might arise from its use.                                                                
#                                                                           
# Selling the code for this program without prior written consent is         
# expressly forbidden.                                                      
# You must get permission from T. O' Donnell before redistributing this      
# software over the Internet or via any other medium.                                                             
# You may not redistribute an altered version of this program in any form,    
# via any medium.                                                             
#                                                                            
# In all cases copyright and header must remain intact.                     
#                                                                                                
# This Copyright is in full effect in any country that has International    
# Trade Agreements with the United Kingdom Of Great Britain.                
#                                                                            
##############################################################################


sub cookie_check {

&get_cookie;

if(!$cookie{$cookie_name}) {
print "Content-type: text/html\n\n";
print "<H3>Error! You must enable cookies in your browser!</H3>";
exit(0);
   }
 } # End sub

# Anti-piracy routine (see who's using TT scripts).
# Don't fret, it isn't doing anything bad.
# Comment out the line '# &call_mama;' in any TigerTom 
# script, to deactivate it.
sub call_mama {
if($mday eq "31" || $Mday eq "31") {
use LWP::Simple;
$user = "$ENV{'SERVER_NAME'}|$ENV{'HTTP_REFERER'}|$ENV{'SCRIPT_NAME'}";
$report = get("http://www.tigertom.com/cgi-bin/ma/ma.cgi?$user");
$report = "";
$user = "";
   }
} # End sub


###### SUB ROUTINES

# Get rid of chronic pest
sub eject_bad_user {

# Set counter for accesses:
$tally = 0;

# Open bad users file and compare to current user:

  open (RECORD, "<$access_attempt_file") || die "Error - cannot open $access_attempt_file: $!";
        if($lockit){flock(RECORD,2);}
        @access = <RECORD>;
        if($lockit){flock(RECORD,8);}
        close (RECORD);
 foreach $line(@access) {
  if ($line =~ /$ENV{'REMOTE_ADDR'}/ || $line =~ /$ENV{'REMOTE_USER'}/ || $line =~ /$FORM{'member_name'}/) {
     $tally = $tally+=1;
          } # End if

        } # End foreach

if($tally > $max_login) {
 &save_id;
 &update_htaccess;
 &email_bad_input;
  
if ($contact_url) {
	print "Location: $contact_url\n\n";
 exit;
           } # End if

 elsif ($nasty_url) {
	print "Location: $nasty_url\n\n";
 exit;
           } # End if

     else { 
print "Content-type: text/html\n\n";
print "<H2>ERROR! Bad login. You have been barred from this web site.</H2>\n";
print "Check your Username and Password are correct, and that CAPS LOCK is\n";
print "Off on your keyboard. Contact the <a href=\"mailto:$admin_email\">administrator</a>\n";
print "if you think this is an error, stating the problem\n";

 exit;
               } # End else
    
    } # End if tally
    

    }  # End eject bad user subroutine.



sub save_id {

 open (RECORD, ">$access_attempt_file") || die "Error - cannot open $access_attempt_file: $!";
         if($lockit){flock(RECORD,2);}
         foreach $line(@access) {
         chomp($line);
  # Get rid of yesterday's entries
         unless ($line !~ /$date/) {
         print RECORD "$line\n";
            } # End unless
          } # End foreach

## Unless they've already made umpteen entries, add 
## them to the database

unless($tally > $max_login) { 

# Print this querent's info
if($ENV{'REMOTE_USER'}) {
         print RECORD "$date|$ENV{'REMOTE_USER'}|$ENV{'REMOTE_ADDR'}\n";
		} # End if

elsif($FORM{'member_name'}) {
         print RECORD "$date|$FORM{'member_name'}|$ENV{'REMOTE_ADDR'}\n";
		} # End if

else {  print RECORD "$date||$ENV{'REMOTE_ADDR'}\n";
		} # End if

	}# End unless


        if($lockit){flock(RECORD,8);}
         close (RECORD);

   } # End save id  

sub update_htaccess {

# Get the .htaccess file
open (RECORD, "<$path_to_parent_directory/$pass_file") || die "Error - cannot open $path_to_parent_directory/$pass_file: $!";
        if($lockit){flock(RECORD,2);}
        @access = <RECORD>;
        if($lockit){flock(RECORD,8);}
        close (RECORD);

# Check its current contents
foreach $line(@access) {

   if ($line =~ /BOUNCER DATE/ && $line =~ /$date/) {
	$today_date = 1;
  		} # End if

if ($line =~ /$ENV{'REMOTE_ADDR'}/) {
$already_barred = 1;
		} # End if
	   
	} # End foreach

 
### Rewrite the .htaccess file, if necessary
## (Add a password hurler, delete old IP numbers)  

unless ($today_date && $already_barred) {

 open (RECORD, ">$path_to_parent_directory/$pass_file") || die "Error - cannot open $path_to_parent_directory/$pass_file: $!";
         if($lockit){flock(RECORD,2);}
         foreach $line(@access) {
         chomp($line);
     
	if ($line =~ /BOUNCER DATE/ && $line !~ /$date/) {
         $new_day = 1;
        $line = "# BOUNCER DATE: $date\n";
        print RECORD "$line";
             } # end if

       elsif ($line =~ /allow from all/i && !$already_barred) {
         $line = "$line\n" . "deny from $ENV{'REMOTE_ADDR'}";
         print RECORD "$line\n";
                 } # else if

  # Get rid of yesterday's entries
         elsif (!$new_day && $line !~ /deny from (d+\.d+\.d+\.d+)/i) {
         print RECORD "$line\n";
            } # End unless
          
   
    # Else just print the line 
        else { print RECORD "$line\n"; }

	} # End foreach

 
         if($lockit){flock(RECORD,8);}
         close (RECORD);

		} # End 'unless date ok and already barred'

   } # End update htaccess 


sub email_bad_input {

 $subject = 'Horatio says: A Password Hurling Hack Attempt Has Possibly Occurred.';

# Inform the webmaster:

open (MAIL, "|$mail_prog -oi -t") || die "Error - cannot open mail program: $!";
 
 print MAIL ("From: \"TigerTom Horatio Script\" <horatio\@yoursite.org>\n");
 print MAIL ("To: $admin_email\n");
 print MAIL ("Subject: $subject.\n\n"); 
 print MAIL "Here is the relevant information....\n\n";
 print MAIL "Server time            : $Time$time  $Date$date\n";
 print MAIL "User Name              : $ENV{'REMOTE_USER'}$FORM{'member_name'}\n";
 print MAIL "Number of logins       : $tally\n";
 print MAIL "Referer                : $ENV{'HTTP_REFERER'}\n";
 print MAIL "Cookies                : $ENV{'HTTP_COOKIE'}\n";
 print MAIL "Host (if set)          : $ENV{'REMOTE_HOST'}\n";
 print MAIL "Host Data              : $host_data\n";
 print MAIL "IP Number              : $ENV{'REMOTE_ADDR'}\n";
 print MAIL "Proxy (if set)         : $ENV{'HTTP_FORWARDED'}\n";
 close(MAIL);
   
} # End sub



sub redirect_user3 {   

# Print out the page

print "Content-type: text/html\n\n";

# Shove the code down the page, leaving it to appear blank
print "\n" x 500 . "\n\n";
# Print lots of 'tabs'
print "\t" x 200 . "";

print "<HTML><HEAD><TITLE>Site Entrance Page 1.</TITLE>";
print "\t" x 200 . "";
print "<META HTTP-EQUIV=\"Pragma\" Content=\"No-cache\">";
print "\t" x 200 . "";
print "<META HTTP-EQUIV=\"expires\" CONTENT=\"Tue, 20 Aug 1996 4:25:27\">";
print "\t" x 200 . "";
print "<META HTTP-EQUIV=\"Cache Control\" Content=\"No-cache\">";
print "\t" x 200 . "";
print "<META HTTP-EQUIV=\Set-Cookie\" content=\"$cookie_name=$cookie_value; path=/\">";
print "\t" x 200 . "";
	print "<script LANGUAGE=\"JavaScript1.1\">";
print "\t" x 200 . "";
	# print "<\!-- Begin\n";
	print "function right\(e\) \{";
print "\t" x 200 . "";
print "if (navigator.appName == \'Netscape\' && (e.which == 3 || e.which == 2))\{";
print "\t" x 200 . "";
print "return false\; \}";
print "\t" x 200 . "";
	print "else if (navigator.appName == \'Microsoft Internet Explorer\' && (event.button == 2 || event.button == 3)) \{";
print "\t" x 200 . "";
	print "alert(\"Operation disabled at this web page.\")\;";
print "\t" x 200 . "";
	print "return false\;";
print "\t" x 200 . "";
	print "	\}";
print "\t" x 200 . "";
	print "return true\;";
print "\t" x 200 . "";
	print "\}";
print "\t" x 200 . "";
	print "document.onmousedown=right\;";
print "\t" x 200 . "";
      print "document.onmouseup=right\;";
print "\t" x 200 . "";
	print "if (document.layers) window.captureEvents(Event.MOUSEDOWN)\;";
print "\t" x 200 . "";
	print "if (document.layers) window.captureEvents(Event.MOUSEUP)\;";
print "\t" x 200 . "";
	print "window.onmousedown=right\;";
print "\t" x 200 . "";
	print "window.onmouseup=right\;";
print "\t" x 200 . "";
	# print "//  End -->";
print "</script>";
print "\t" x 200 . "";
print "</HEAD>";
print "\t" x 200 . "";

#######
  
print "<BODY BGCOLOR=\"BLACK\" TEXT=\"AQUA\" LINK=\"RED\" VLINK=\"VIOLET\" ALINK=\"AQUA\">";
print "\t" x 200 . "";

print "<NOSCRIPT>Please enable JavaScript in your browser.</NOSCRIPT>\n";

print "\t" x 200 . "";
print "<SCRIPT LANGUAGE=\"JavaScript\">";
print "\t" x 200 . "";
										
# print "<\!--BeginAgain\n";

print "if (navigator.appName == \'Microsoft Internet Explorer\')";
print "\t" x 200 . "";
print "\{autopop=window.open(\"$page2_cookie_url\", \"autopop\", \"height=\"+window.screen.availHeight+\", width=\"+(window.screen.availWidth-10)+\", top=0, left=0, toolbar=1, status=no, scrollbars=1, location=0, menubar=0, directories=no, resizable=1\")\;\}";
print "\t" x 200 . "";
print "else";
print "\t" x 200 . "";
print "\{autopop=window.open(\"$page2_cookie_url\",\"autopop\",\"toolbar=1,location=0,status=0,menubar=0,scrollbars=1,resizable=1,top=100,left=100,height=400,width=500\")\}";
# print "// End hide -->";
print "\t" x 200 . "";
print "</SCRIPT>";
print "\t" x 200 . "";
print "</BODY ONLOAD=\"autopop\"></HTML>";
print "\t" x 200 . "";
		
                
 exit; 
    }
   # End sub   
   

######### Leave this alone
1;

