#!/usr/bin/perl

####################################################################
#                                                                  #
#  DISCLAIMER:                                                     #
#  In no event will T. O' Donnell be liable to the user of this    # 
#  script or any third party for any damages, including any lost   #
#  profits, lost savings or other incidental, consequential or     #
#  special damages arising out of the operation of or inability to # 
#  operate this script, even if the user has been advised of the   # 
#  possibility of such damages.                                    #
####################################################################
##############################################################################
# COPYRIGHT NOTICE                                                           
# TigerTom's Horatio HTML Obfuscation Script. Version: 1.0, April 2002.                 
#                                                                             
# Copyright 2001-2002 T. O' Donnell.  All Rights Reserved.                        
# http://www.tigertom.com/contact.htm                                      
#                                                                            
# This Perl script may be used and modified by any purchaser so               
# long as this copyright notice and the comments below remain intact.
# It may only be used on domains owned by the purchaser.                                                                         
# By using this code you agree to indemnify T. O' Donnell Inc. and T. O' 
# Donnell from any liability that might arise from its use.                                                           
#                                                                           
# Selling the code for this program without prior written consent is       
# expressly forbidden.                                                     
# You must get permission from T. O' Donnell before redistributing this      
# software over the Internet or via any other medium.                                                            
# You may not redistribute an altered version of this program in any form,    
# via any medium.                                                             
#                                                                            
# In all cases copyright and header must remain intact.                     
#                                                                                                
# This Copyright is in full effect in any country that has International     
# Trade Agreements with the United Kingdom Of Great Britain.                 
#                                                                            
##############################################################################

# Horatio HTML Obfuscation script by T. O' Donnell, May 2002.
# Copyright T. O' Donnell, May 2002.


use CGI::Carp qw(fatalsToBrowser);
require "tigertom_lib.cgi";
require "horatio_setup.cgi";


### JavaScript de_obfuscation code

$JavaScript_de_obfuscation_code_header ="<HTML><SCRIPT LANGUAGE=\"JavaScript\">var theText = new String(\"";

$JavaScript_de_obfuscation_code_footer =<<'OUTPUT';

var key_array = new Array(); key_array["u"] = "1"; key_array["v"] = "2"; key_array["Z"] = "3"; key_array["a"] = "4"; key_array["b"] = "5"; key_array["e"] = "6"; key_array["f"] = "7"; key_array["g"] = "8"; key_array["w"] = "9"; key_array["U"] = "0"; key_array["V"] = "a"; key_array["O"] = "b"; key_array["P"] = "c"; key_array["Q"] = "d"; key_array["R"] = "e"; key_array["S"] = "f"; key_array["T"] = "g"; key_array["j"] = "h"; key_array["k"] = "i"; key_array["9"] = "j"; key_array["0"] = "k"; key_array["r"] = "l"; key_array["D"] = "m"; key_array["E"] = "n"; key_array["F"] = "o"; key_array["x"] = "p"; key_array["y"] = "q"; key_array["z"] = "r"; key_array["A"] = "s"; key_array["B"] = "t"; key_array["W"] = "u"; key_array["X"] = "v"; key_array["Y"] = "w"; key_array["4"] = "x"; key_array["5"] = "y"; key_array["6"] = "z"; key_array["c"] = "A"; key_array["d"] = "B"; key_array["7"] = "C"; key_array["8"] = "D"; key_array["G"] = "E"; key_array["s"] = "F"; key_array["t"] = "G"; key_array["M"] = "H"; key_array["N"] = "I"; key_array["h"] = "J"; key_array["i"] = "K"; key_array["H"] = "L"; key_array["I"] = "M"; key_array["J"] = "N"; key_array["K"] = "O"; key_array["L"] = "P"; key_array["1"] = "Q"; key_array["2"] = "R"; key_array["3"] = "S"; key_array["C"] = "T"; key_array["l"] = "U"; key_array["m"] = "V"; key_array["n"] = "W"; key_array["o"] = "X"; key_array["p"] = "Y"; key_array["q"] = "Z";  var TextSize = theText.length; var i = 0; var Results = ''; var Temp = '';  while (i<=TextSize - 1) { Temp=theText.charAt(i); if(!key_array[Temp]) {Results+=Temp; }else { Results+=key_array[Temp]; }  i++;   } document.write(Results); // exit; </script><HTML>

OUTPUT

################

 if ($ENV{'QUERY_STRING'} eq $the_password) {

# Content-type header:
$content_type = '<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">';

# Put the 'no-cache' meta tags into a scalar
$nocache_tags = '<META HTTP-EQUIV="Pragma" Content="No-cache"><META HTTP-EQUIV="expires" CONTENT="Tue, 20 Aug 1996 4:25:27"><META HTTP-EQUIV="Cache Control" Content="no-cache,must-revalidate,no-store"><meta http-equiv="imagetoolbar" content="no">';
$head_tag = '<HEAD>';

# Put JavaScript 'no-right-click' tag into a scalar
if($insert_NoRightClickCode) {
$no_right_click_code = "<script LANGUAGE=\"JavaScript1.1\"> function right\(e\) \{ if \(navigator.appName \=\= \'Netscape\' \&\& \(e.which \=\= 3 \|\| e.which \=\= 2\)\) \{return false\;\} else if \(navigator.appName \=\= \'Microsoft Internet Explorer\' \&\& \(event.button \=\= 2 \|\| event.button \=\= 3\)\) \{ alert\(\"Operation disabled at this web page.\"\)\; return false\; \} return true\; \} document.onmousedown\=right\; document.onmouseup\=right\; if \(document.layers\) window.captureEvents\(Event.MOUSEDOWN\)\;	if \(document.layers\) window.captureEvents\(Event.MOUSEUP\)\; window.onmousedown\=right\; window.onmouseup\=right\; </script>";               
          }

# Start the conversion

			# Begin notice
		
			print "Content-type: text/html\n\n";
			print "<FONT FACE=\"Verdana,Arial\"><H3>Horatio is starting to obfuscate...</H3></FONT><FONT FACE=\"Verdana,Arial\" FACE=\"1\">";

# Make a backup of the files we're about to change:

 if($zipname) {
 unless(-e, "$path_to_protected_directory/$zipname") {
 system("$zip_loc -9qr $path_to_protected_directory/$zipname $path_to_protected_directory") or die "Can't make zipfile $path_to_protected_directory/$zipname: $!";
  } # End unless
 } # End if

# $zip_result = `$zip_loc \"$path_to_protected_directory/$zipname $path_to_protected_directory\"`;
# print "$zip_result\n";
# exit;

# Get the directory of files to obfuscate, and get their names:
opendir(DIR, "$path_to_protected_directory") or die "Can't open $path_to_protected_directory: $!";
@FilesInDirectory = readdir(DIR);
closedir(DIR);

			print "Got the file names in <I>$path_to_protected_directory</I>  ...<BR><BR>\n\n";
		


# Go through the file names to find ones that need changing:

foreach $file (@FilesInDirectory) { 

	# Set a counter to flip thorough the file extension array:
	$counter = 0;
	 while($counter <= $#FileExtension) {

   		if($file =~ /$FileExtension[$counter]$/i) {

        
# Assign the file path a scalar
$FullFileName = $path_to_protected_directory . "/" . $file;

# Open the file to get its data
open(INPUT, "<$FullFileName") or die "Can't open $FullFileName: $!";         
@lines = <INPUT>;
close(INPUT);

			print "Acquired <I>$FullFileName</I>.<BR>\n";


			print "Obfuscating <I>$FullFileName</I>.<BR><BR>\n";



# Now go thorough data again:

foreach $line (@lines) {


# Insert NO-CACHE meta tags
if ($insert_nocache) {
if ($line =~ /$head_tag/i) {
 $line =~ s/$head_tag/$head_tag$nocache_tags$no_right_click_code/gi;
           } # End if
         } # End if


# Insert content-type header tag

 if ($line =~ /$head_tag/i) {
 $line =~ s/$head_tag/$head_tag$content_type/gi;
                  } # End if


# Then, swop image urls for horatio_pic.php

 if($insert_horatio_pic_link) {

 if ($line =~ /img src=\"/i) {
  if ($line !~ /img src=\"http/i && $line !~ /img src=\"horatio_pic.php\?.+/i) {
	if($line =~ /img src=\"\w+\.(gif|jpg|bmp|png)\"/i) {
	$line =~ s/src=\"/src=\"horatio_pic.php\?/gi;
                      } # End if
    if($line =~ /img src=\".+\/\w+\.(gif|jpg|bmp|png)\"/i) { 
           $line =~ s/src=\".+\/.+\/.+\//src=\"/gi;
           $line =~ s/src=\".+\/.+\//src=\"/gi;
	   $line =~ s/src=\".+\//src=\"/gi;
	   $line =~ s/src=\"/src=\"horatio_pic.php\?/gi;
                	       } # End if
			 } # End if
        	} # End if
	} # End if



	# Swop alpha-numeric characters for our own set (encoding /encryption )

	$line =~ tr/1234567890abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ/uvZabefgwUVOPQRSTjk90rDEFxyzABWXY456cd78GstMNhiHIJKL123Clmnopq/; 

        $string_to_decode = $string_to_decode . $line;
	 # Get rid of unencoded text
         $line = '';     

   	} # End foreach line (2)


# Reverse encoded HTML
# $string_to_decode = reverse($string_to_decode);

# Comment out some non-alpha-numeric characters
$string_to_decode =~ s/\"/\\"/g;
$string_to_decode =~ s/\;/\\;/g;

# Delete ALL newlines and returns

$string_to_decode =~ s/\n//g;
$string_to_decode =~ s/\r//g;
	

# Overwrite file with part-obfuscated code.
open(OUTPUT, ">$FullFileName") or die "Can't open $FullFileName: $!";  

# Print data

# Print a marker to say we've done this file.
# print OUTPUT "<!--// HORATIO 2002 //-->\n";

 if ($move_code) {
# Shove the code down the page, leaving it to appear blank
	print OUTPUT "\n" x 1000 . "\n\n";
	} # End if


# Get rid of newlines in JS footer
# $JavaScript_de_obfuscation_code_footer =~ s/\n//g;

if ($move_code) {print OUTPUT "\t" x 200 . ""; } # Print lots of 'tabs' on line
print OUTPUT "$JavaScript_de_obfuscation_code_header";
print OUTPUT "$string_to_decode";
print OUTPUT "\")\;";
if ($move_code) {print OUTPUT "\t" x 200 . ""; } # Print lots of 'tabs' on line
print OUTPUT "$JavaScript_de_obfuscation_code_footer";
close(OUTPUT);

# Dump data
$string_to_decode = '';

			print "<H4><I>$FullFileName</I> successfully obfuscated!</H4>\n\n";
   		
	        } # End if
	$counter = $counter + 1;	
	} # End while
	
  } # End foreach (1)

			print "<H3>Files in <I>$path_to_protected_directory</I> successfully obfuscated!</H3></FONT>\n\n";
exit(0);
     
   } # End if password

	 else { 
		print "Content-type: text/html\n\n";
		print "<H2>Error! No password or bad password!</H2>";
		exit(0);
		}

########
